# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

# define the function f and its gradient
scenario = -1   #will be set in 1d_shapeopt
a =4.0/5.0
b = 2
fclover = CoefficientFunction((sqrt((X[0] - a)**2 + b * X[1]**2) - 1) \
               * (sqrt((X[0] + a)**2 + b * X[1]**2) - 1) \
               * (sqrt(b * X[0]**2 + (X[1] - a)**2) - 1) \
               * (sqrt(b * X[0]**2 + (X[1] + a)**2) - 1) - 0.001)     #optimal design is clover

aa = 1.3
fellipse = CoefficientFunction(1/aa*X[0]*X[0] + aa*X[1]*X[1] - 1)       #optimal design is ellipse

def Cost_vol(u): 
    if scenario == 1 or scenario == 2:
        return fellipse*Det(F)*dx
    else:
        return fclover*Det(F)*dx
    
def Cost_bnd(u): 
    return 0*u*ds

costbnd = False
