# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

order = 1
fes = H1(mesh, order=order, dirichlet="circle")

F = Id(2)
f = CoefficientFunction(2*X[1]*(1-X[1])+2*X[0]*(1-X[0]))

def Equation_vol(u,v):
   return ( (Inv(F.trans)*grad(u))*(Inv(F.trans)*grad(v))-f*v)*Det(F)*dx
def Equation_bnd(u,v):
   return 0*u*v*ds

def solvePDE():
    Newton(a, gfu, printing = False)
                
    dCostdu.Assemble()
    a.AssembleLinearization(gfu.vec)

    inva = a.mat.Inverse(fes.FreeDofs(), inverse="sparsecholesky")
    gfp.vec.data = -inva.T * dCostdu.vec


isComplex = False
isSurface = False
