# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

#if newton == True and regExt==True then newton system is solved only on boundary (i.e. for dofs specified by dirichletOpti) and then extended to the interior; thus, in this case, dirichletOpti does not specify Dirichlet conditions for the vector field
scenario = 2
#1 newton with regularization only at boundary
#2 newton with H1 regularization
#3 gradient method

if scenario == 1:
    newton = True
    dirichletOpti = "circle"
    regExt = True                         #only relevant for newton == True
    delta_regHess = 1                   #only relevant for newton == True
    nDampedSteps = 10               #only relevant for newton == True
elif scenario == 2:
    newton = True
    dirichletOpti = ""
    regExt = False                      #only relevant for newton == True
    delta_regHess = 0.001             #only relevant for newton == True
    nDampedSteps = 0                #only relevant for newton == True
else:
    newton = False
    dirichletOpti = ""
    regExt = False                      #only relevant for newton == True
    delta_regHess = 0                 #only relevant for newton == True
    nDampedSteps = 0                #only relevant for newton == True

lineSearch = False                  #only relevant for newton == False
armijo_param = 0                    #only relevant for newton == False and lineSearch == True

moveMesh = False
nMeshOpti = -1
CR = False                              #Cauchy Riemann term
gamma_CR = 100                    #only relevant for CR == True

scale_init =  1                         #only relevant for newton == False
scaleIncreaseFactor = 1         #only relevant for newton == False and lineSearch == True

iter_max = 200 
tol_scale = 1e-10
tol_gfX = 1e-7
tol_J = 1e-10

myAlpha = 1
