# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

 
geo = SplineGeometry()

lenA = 0.12
lenB = 0.05
pnts =[(0,0),
       (1,0.4),
       (1,0.45),
       (1,0.55),
       (1,0.6),
       (0,1),
       (0,1-lenA),
       (lenB,1-lenA),
       (lenB,1-lenA-lenB),
       (lenB,lenA+lenB),
       (lenB,lenA),
       (0,lenA)]#(0,0.1)]

p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12 = [geo.AppendPoint(*pnt,maxh=0.02) for pnt in pnts]

geo.Append(["line",p1,p2],bc = "bottom")
geo.Append(["line",p2,p3], bc = "right3")
geo.Append(["line",p3,p4], bc = "right2")
geo.Append(["line",p4,p5], bc = "right1")
geo.Append(["line",p5,p6], bc = "top")
geo.Append(["line",p6,p7], bc = "left1")
geo.Append(["spline3",p7,p8,p9], bc = "left2a")
geo.Append(["line",p9,p10], bc = "left2b")
geo.Append(["spline3",p10,p11,p12], bc = "left2c")
geo.Append(["line",p12,p1], bc = "left3")

geo.AddCircle(c=(0.3,0.65),r=0.05, bc="circle1", leftdomain=0,rightdomain=1)
geo.AddCircle(c=(0.3,0.35),r=0.05, bc="circle2", leftdomain=0,rightdomain=1)
geo.AddCircle(c=(0.5,0.5),r=0.1, bc="circle0", leftdomain=0,rightdomain=1)

mesh = Mesh(geo.GenerateMesh(maxh=0.01))
mesh.Curve(3)
