# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

geo = SplineGeometry()

nese = True
pnts =[(1,0.5),
    (1,1),
    (0.5,1),
    (0,1),
    (0,0.5),
    (0,0),
    (0.5,0),
    (1,0)]


p1,p2,p3,p4,p5,p6,p7,p8 = [geo.AppendPoint(*pnt) for pnt in pnts]

curves = [ [["spline3",p1,p2, p3],"ne"],
        [["spline3",p3,p4, p5],"nw"],
        [["spline3",p5,p6, p7],"sw"],
        [["spline3",p7,p8, p1],"se"]]
[geo.Append(c,bc=bc) for c,bc in curves]

geo.AddCircle((0.75, 0.5), 0.1,  bc="scat", leftdomain=0, rightdomain=1, maxh=0.003)

mesh = Mesh(geo.GenerateMesh(maxh=0.005))


