# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

from netgen.csg import *
from netgen.meshing import *
from ngsolve.internal import visoptions
from ngsolve import *

geo = CSGeometry()
sphere = Sphere(Pnt(0,0,0),1).bc("outer")
geo.Add(sphere)
mesh = Mesh(geo.GenerateMesh(perfstepsend=MeshingStep.MESHSURFACE,optsteps2d=3,maxh=0.2))
mesh.Curve(3)

dim = mesh.dim
