# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

order = 3
fes = H1(mesh,order = order)

F = Id(3)
tangDet = Det(F) * Norm( Inv(F).trans*specialcf.normal(3) )
Bmat = (Id(3) - 1/Norm(Inv(F).trans*specialcf.normal(3))**2 * OuterProduct(Inv(F).trans*specialcf.normal(3), Inv(F).trans*specialcf.normal(3)) ) * Inv(F).trans

func = CoefficientFunction(X[0]*X[1]*X[2])

def Equation_vol(u,v):
    return ( 0* u * v) * dx
def Equation_bnd(u,v):
    return ( (Bmat*grad(u).Trace()) * (Bmat*grad(v).Trace()) + u.Trace()*v.Trace() - func * v.Trace()) * tangDet * ds

def solvePDE():
    Newton(a, gfu, printing = False)
    
    dCostdu.Assemble()
    a.AssembleLinearization(gfu.vec)
    inva = a.mat.Inverse(fes.FreeDofs(), inverse="sparsecholesky")
    gfp.vec.data = -inva.T * dCostdu.vec

isComplex = False
isSurface = True
