# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

geo = SplineGeometry()
x1left = 0.2
x1right = 0.8
pnts =[(x1left,0),
       (x1right,0),
       (x1right,1),
       (x1left,1)]
p1,p2,p3,p4 = [geo.AppendPoint(*pnt) for pnt in pnts]
geo.Append(["line",p1,p2],leftdomain=1, rightdomain=0, bc="bottom")
geo.Append(["line",p2,p3],leftdomain=1, rightdomain=0, bc="right")
geo.Append(["line",p3,p4],leftdomain=1, rightdomain=0, bc="top")
geo.Append(["line",p4,p1],leftdomain=1, rightdomain=0, bc="left")

mesh = Mesh(geo.GenerateMesh(maxh=0.02))
