# Supplementary material to the manuscript entitled
#       "Fully and Semi-Automated Shape Differentiation in NGSolve"
# by the authors
#       P. Gangl, K. Sturm, M. Neunteufel, J. Schoeberl
# submitted to the journal
#        Structural and Multidisciplinary Optimization
# Corresponding author: 
#       Peter Gangl, Institute of Applied Mathematics, 
#       Graz University of Technology, Graz, Austria
#       gangl@math.tugraz.at

order = 1
fes = H1(mesh, order=order, dirichlet="bottom|left|right")
fesAdj = H1(mesh, order=order, dirichlet="left|top|right")
p,w = fesAdj.TnT()
aAdj = BilinearForm(fesAdj, symmetric = False)
aAdj += (grad(p)[1] * w + grad(p)[0]*grad(w)[0] )*dx

F11 = Parameter(1)
F12 = Parameter(0)
F21 = Parameter(0)
F22 = Parameter(1)
F = CoefficientFunction((F11, F12, F21, F22), dims=(2,2)) #Id(2)

f = CoefficientFunction((X[0]*(1-X[0])+2*X[1]))

def Equation_vol(u,v):
   return ( (Inv(F.trans)*grad(u))[1]*v + (Inv(F.trans)*grad(u))[0]*(Inv(F.trans)*grad(v))[0]-f*v)*Det(F)*dx

def solvePDE():
    Newton(a, gfu, printing = False)
    
    dCostdu.Assemble()
    aAdj.Assemble()
    invaAdj = aAdj.mat.Inverse(fesAdj.FreeDofs(), inverse="umfpack")
    gfp.vec.data = -invaAdj * dCostdu.vec


